+2024-03-05 Bruno Haible <bruno@clisp.org>
+
+ c-strtold: Add multithread-safety test.
+ * tests/test-c-strtold-mt.c: New file.
+ * tests/test-c-strtold-mt.sh: New file, based on
+ tests/test-c-strtold1.sh.
+ * modules/c-strtold-tests (Files): Add them.
+ (Depends-on): Add thread, nanosleep.
+ (Makefile.am): Arrange to build test-c-strtold-mt and run
+ test-c-strtold-mt.sh.
+
2024-03-05 Bruno Haible <bruno@clisp.org>
c-strtod: Add multithread-safety test.
tests/test-strtold.h
tests/test-c-strtold1.sh
tests/test-c-strtold1.c
+tests/test-c-strtold-mt.sh
+tests/test-c-strtold-mt.c
tests/minus-zero.h
tests/macros.h
m4/locale-fr.m4
isnanl-nolibm
signbit
setlocale
+thread
+nanosleep
configure.ac:
gt_LOCALE_FR
TESTS += test-c-strtold
check_PROGRAMS += test-c-strtold
-TESTS += test-c-strtold1.sh
+TESTS += test-c-strtold1.sh test-c-strtold-mt.sh
TESTS_ENVIRONMENT += \
LOCALE_FR='@LOCALE_FR@' \
LOCALE_FR_UTF8='@LOCALE_FR_UTF8@' \
LC_NUMERIC_IMPLEMENTED='@LC_NUMERIC_IMPLEMENTED@'
-check_PROGRAMS += test-c-strtold1
+check_PROGRAMS += test-c-strtold1 test-c-strtold-mt
test_c_strtold1_LDADD = $(LDADD) $(SETLOCALE_LIB)
+test_c_strtold_mt_LDADD = $(LDADD) $(SETLOCALE_LIB) $(LIBMULTITHREAD) $(NANOSLEEP_LIB)
--- /dev/null
+/* Multithread-safety test for c_strtold().
+ Copyright (C) 2024 Free Software Foundation, Inc.
+
+ This program is free software: you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation, either version 3 of the License, or
+ (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see <https://www.gnu.org/licenses/>. */
+
+/* Written by Bruno Haible <bruno@clisp.org>, 2024. */
+
+#include <config.h>
+
+/* Work around GCC bug 44511. */
+#if 4 < __GNUC__ + (3 <= __GNUC_MINOR__)
+# pragma GCC diagnostic ignored "-Wreturn-type"
+#endif
+
+#if USE_ISOC_THREADS || USE_POSIX_THREADS || USE_ISOC_AND_POSIX_THREADS || USE_WINDOWS_THREADS
+
+/* Specification. */
+#include "c-strtod.h"
+
+#include <errno.h>
+#include <locale.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <time.h>
+
+#include "glthread/thread.h"
+
+static void *
+thread1_func (void *arg)
+{
+ const char input[] = "1,5";
+
+ for (;;)
+ {
+ char *ptr;
+ long double result;
+ errno = 0;
+ result = c_strtold (input, &ptr);
+ if (!(result == 1.0L && ptr == input + 1 && errno == 0))
+ {
+ fprintf (stderr, "thread1 malfunction!\n"); fflush (stderr);
+ abort ();
+ }
+ }
+
+ /*NOTREACHED*/
+}
+
+static void *
+thread2_func (void *arg)
+{
+ const char input[] = "1,5";
+
+ for (;;)
+ {
+ char *ptr;
+ long double result;
+ errno = 0;
+ result = strtold (input, &ptr);
+ if (!(result == 1.5L && ptr == input + 3 && errno == 0))
+ {
+ fprintf (stderr, "thread2 disturbed by thread1!\n"); fflush (stderr);
+ abort ();
+ }
+ }
+
+ /*NOTREACHED*/
+}
+
+static void *
+thread3_func (void *arg)
+{
+ for (;;)
+ {
+ char pointbuf[5];
+ sprintf (pointbuf, "%#.0f", 1.0);
+ if (!(pointbuf[1] == ','))
+ {
+ fprintf (stderr, "thread3 disturbed by thread1!\n"); fflush (stderr);
+ abort ();
+ }
+ }
+
+ /*NOTREACHED*/
+}
+
+int
+main (int argc, char *argv[])
+{
+ /* Try to set the locale by implicitly looking at the LC_ALL environment
+ variable.
+ configure should already have checked that the locale is supported. */
+ if (setlocale (LC_ALL, "") == NULL)
+ return 1;
+
+ /* Create the threads. */
+ gl_thread_create (thread1_func, NULL);
+ gl_thread_create (thread2_func, NULL);
+ gl_thread_create (thread3_func, NULL);
+
+ /* Let them run for 1 second. */
+ {
+ struct timespec duration;
+ duration.tv_sec = (argc > 1 ? atoi (argv[1]) : 1);
+ duration.tv_nsec = 0;
+
+ nanosleep (&duration, NULL);
+ }
+
+ return 0;
+}
+
+#else
+
+/* No multithreading available. */
+
+#include <stdio.h>
+
+int
+main ()
+{
+ fputs ("Skipping test: multithreading not enabled\n", stderr);
+ return 77;
+}
+
+#endif
--- /dev/null
+#!/bin/sh
+
+: "${LOCALE_FR=fr_FR}"
+: "${LOCALE_FR_UTF8=fr_FR.UTF-8}"
+
+if test $LOCALE_FR = none && test $LOCALE_FR_UTF8 = none; then
+ if test -f /usr/bin/localedef; then
+ echo "Skipping test: no locale for testing is installed"
+ else
+ echo "Skipping test: no locale for testing is supported"
+ fi
+ exit 77
+fi
+
+if $LC_NUMERIC_IMPLEMENTED; then
+ :
+else
+ echo "Skipping test: LC_NUMERIC category of locales is not implemented"
+ exit 77
+fi
+
+if test $LOCALE_FR != none; then
+ LC_ALL=$LOCALE_FR ${CHECKER} ./test-c-strtold-mt${EXEEXT} || exit 1
+fi
+
+if test $LOCALE_FR_UTF8 != none; then
+ LC_ALL=$LOCALE_FR_UTF8 ${CHECKER} ./test-c-strtold-mt${EXEEXT} || exit 1
+fi
+
+exit 0